#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <glib.h>
#include <tapidbus/tapidbus.h>

#include <stdlib.h>

int main(int argc, char **argv)
{
    GMainLoop *loop;
	TapiDBus *td;
	DBusMessage *msg;
    gchar *str = NULL;
    
    if (argc < 3) {
        g_print ("usage: %s string int\n", argv[0]);
        return 1;
    }

    loop = g_main_loop_new (NULL, FALSE);

	td = tapidbus_new ();
	msg = tapidbus_send_with_reply_block (td,
            "org.maemo.TapiDBus",
            "/org/maemo/TapiDBus/c1",
            "org.maemo.TapiDBus",
            "TestMethod",
            3000,
            DBUS_TYPE_STRING,
            argv[1], 
            DBUS_TYPE_INVALID);

    if ((tapidbus_get_string (msg, &str)) == FALSE) {
	    g_print ("invalid reply\n");
    }
    else {
	    g_print ("reply '%s'\n", str);
    }
    
    if (tapidbus_emit_signal (td,
            "/org/maemo/TapiDBus/c1",
            "org.maemo.TapiDBus",
            "TestSignal",
            DBUS_TYPE_INT32,
            atoi (argv[2]), 
            DBUS_TYPE_INVALID)) {
        g_print ("signal emitted\n");
    }

    msg = tapidbus_send_with_reply_block (td,
            "org.maemo.TapiDBus",
            "/org/maemo/TapiDBus/c2",
            "org.maemo.TapiDBus",
            "TestMethod",
            3000,
            DBUS_TYPE_STRING,
            argv[1], 
            DBUS_TYPE_INVALID);

    if ((tapidbus_get_string (msg, &str)) == FALSE) {
	    g_print ("invalid reply\n");
    }
    else {
	    g_print ("reply '%s'\n", str);
    }
    
    if (tapidbus_emit_signal (td,
            "/org/maemo/TapiDBus/c2",
            "org.maemo.TapiDBus",
            "TestSignal",
            DBUS_TYPE_INT32,
            atoi (argv[2]), 
            DBUS_TYPE_INVALID)) {
        g_print ("signal emitted\n");
    }

	tapidbus_destroy (td);

	return 0;
}

